xe = xe or xes

XEWorldController = xe.Scene

warning_table = {}
_print_warning = print_warning
print_warning = function(str)
    if warning_table[str] then
        return
    end
    warning_table[str] = true
    _print_warning(str)
end

_G_Director = xe.Director:GetInstance()
function xe.Director:GetInstance()
    return _G_Director
end
_G_EngineInstance = _G_Director:GetEngine()

function IXPlatformWindow.GetViewport()
    print_warning('Window:GetViewport() 已被废弃 请使用 _G_Director:GetViewport() 替代')
    return _G_Director:GetViewport()
end

--xe.Scheduler
xe.Scheduler.INTERVAL_NEXT_TICK = -2
function xe.Scheduler:time()
    return getMillisecond()
end

--Global
function IXUIManager:GetGlobal()
    print_warning('IXUIManager:GetGlobal() 已被废弃 请使用 _G_EngineInstance:GetUIManager 替代')
    return _G_EngineInstance:GetUIManager();
end

function IXPlatformWindow:GetGlobal()
    print_warning('IXPlatformWindow:GetGlobal() 已被废弃 请使用 _G_Director:GetWindow() 替代')
    return _G_Director:GetWindow();
end

function IX2DPhysicalManager:GetGlobal()
    print_warning('IX2DPhysicalManager:GetGlobal() 已被废弃 请使用 _G_EngineInstance:Get2DPhysicalManager() 替代')
    return _G_EngineInstance:Get2DPhysicalManager()
end

function IXPhysicalManager:GetGlobal()
    print_warning('IXPhysicalManager:GetGlobal() 已被废弃 请使用 _G_EngineInstance:GetPhysicalManager() 替代')
    return _G_EngineInstance:GetPhysicalManager()
end

function IXCanvasBase:GetGlobal()
    print_warning('IXCanvasBase:GetGlobal() 已被废弃 请使用 _G_EngineInstance:GetCanvasBase() 替代')
    return _G_EngineInstance:GetCanvasBase()
end

_G_Director.GetXUIManager = function()
    print_warning('Director.GetXUIManager () 已被废弃 请使用 _G_EngineInstance:GetUIManager() 替代')
    return _G_EngineInstance:GetUIManager();
end

_G_Director.GetXCanvasBase = function()
    print_warning('Director.GetXCanvasBase () 已被废弃 请使用 _G_EngineInstance:GetCanvasBase() 替代')
    return _G_EngineInstance:GetCanvasBase()
end

_G_Director.GetXWindow = function()
    print_warning('Director:GetXWindow() 已被废弃 请使用 _G_Director:GetWindow() 替代')
    return _G_Director:GetWindow();
end

_G_Director.GetX2DPhysicalManager = function()
    print_warning('Director:GetX2DPhysicalManager() 已被废弃 请使用 _G_EngineInstance:Get2DPhysicalManager() 替代')
    return _G_EngineInstance:Get2DPhysicalManager()
end

_G_Director.GetXPhysicalManager = function()
    print_warning('Director.GetXPhysicalManager() 已被废弃 请使用 _G_EngineInstance:GetPhysicalManager() 替代')
    return _G_EngineInstance:GetPhysicalManager()
end

_G_Director.GetXModelManager = function()
    print_warning('Director.GetXModelManager () 已被废弃 请使用 _G_EngineInstance:GetModelManager() 替代')
    return _G_EngineInstance:GetModelManager()
end

_G_Director.GetXEditorModelManager = function()
    print_warning('Director.GetXEditorModelManager () 已被废弃 请使用 _G_EngineInstance:GetEditorModelManager() 替代')
    return _G_EngineInstance:GetEditorModelManager()
end

_G_Director.GetXGestureManager = function()
    print_warning('Director.GetXGestureManager() 已被废弃 请使用 _G_EngineInstance:GetGestureManager() 替代')
    return _G_EngineInstance:GetGestureManager()
end

g_pIXUIManager = _G_EngineInstance:GetUIManager();
g_pXWindow = _G_Director:GetWindow();
g_pIX2DPhysicalManager = _G_EngineInstance:Get2DPhysicalManager()
g_pIXPhysicalManager = _G_EngineInstance:GetPhysicalManager()
g_pIXGestureManager = _G_EngineInstance:GetGestureManager()
g_pFxManager = _G_EngineInstance:GetFxManager()
g_pXAnimationManager = _G_EngineInstance:GetAnimationManager()
g_pBlendShapeManager = _G_EngineInstance:GetBlendShapeManager()
g_pBrushManager = _G_EngineInstance:GetBrushManager()
g_pXCanvasBase = _G_EngineInstance:GetCanvasBase()
g_pXConVarSys = _G_EngineInstance:GetConVarSys()
g_pDressupManager = _G_EngineInstance:GetDressupManager()
g_pIXGestureManager = _G_EngineInstance:GetGestureManager()
g_pXImageEffectProcessor = _G_EngineInstance:GetImageEffectProcessor()
g_pXLightMgr = _G_EngineInstance:GetLightManager()
g_pXMaterialMgr = _G_EngineInstance:GetMaterialManager()
g_pXUserMaterialMgr = _G_EngineInstance:GetUserMaterialManager()
g_pXModelManager = _G_EngineInstance:GetModelManager()
g_pXEditorModelManager = _G_EngineInstance:GetEditorModelManager()
g_pPhysicalManagerBase = _G_EngineInstance:GetPhysicalManagerBase()
g_pXCurrentRenderer = _G_EngineInstance:GetRenderer()
g_pXResourceManager = _G_EngineInstance:GetResourceManager()
g_pXTextureManager = _G_EngineInstance:GetTextureManager()

XEEngine = {}
function XEEngine:GetInstance()
    print_warning('XEEngine 已被废弃 请使用 _G_EngineInstance 代替')
    return XEEngine
end

function XEEngine:GetEngineVersion()
    print_warning('XEEngine 已被废弃 请使用 _G_EngineInstance 代替')
    return ''
end
function XEEngine:GetEngineVersionValue()
    print_warning('XEEngine 已被废弃 请使用 _G_EngineInstance 代替')
    return 0
end

function XEEngine:GetEngineVersionCompileTime()
    print_warning('XEEngine 已被废弃 请使用 _G_EngineInstance 代替')
    return ''
end

function XEEngine:GetEngineBaseDir()
    print_warning('XEEngine:GetEngineBaseDir() 已被废弃 请使用 _G_Director:GetBasePath() 代替')
    return _G_Director:GetBasePath();
end

function XEEngine:GetAppProjectResDir()
    print_warning('XEEngine:GetAppProjectResDir() 已被废弃 请使用 _G_Director:GetLibraryPath() 代替')
    return _G_Director:GetLibraryPath();
end

function XEEngine:Resize3DDrawWindow(window)
    print_warning('XEEngine 已被废弃 请使用 _G_EngineInstance 代替')
end

function XEEngine:GetCurrentDrawWindow()
    print_warning('XEEngine 已被废弃 请使用 _G_EngineInstance 代替')
    return _G_Director:GetWindow()
end

XEGame = {}

function XEGame:GetInstance()
    return _G_EngineInstance
end

audio.AudioEngine.__preloadBackgroundMusic__ = audio.AudioEngine.preloadBackgroundMusic
function audio.AudioEngine:preloadBackgroundMusic(path)
    self:__preloadBackgroundMusic__(FileUtils:FullFilePath(path))
end

audio.AudioEngine.__preloadEffect__ = audio.AudioEngine.preloadEffect
function audio.AudioEngine:preloadEffect(path)
    self:__preloadEffect__(FileUtils:FullFilePath(path))
end

audio.AudioEngine.__unloadEffect__ = audio.AudioEngine.unloadEffect
function audio.AudioEngine:unloadEffect(path)
    self:__unloadEffect__(FileUtils:FullFilePath(path))
end

audio.AudioEngine.__playBackgroundMusic__ = audio.AudioEngine.playBackgroundMusic
function audio.AudioEngine:playBackgroundMusic(path, ...)
    return self:__playBackgroundMusic__(FileUtils:FullFilePath(path), ...)
end

audio.AudioEngine.__playEffect__ = audio.AudioEngine.playEffect
function audio.AudioEngine:playEffect(path, ...)
    return self:__playEffect__(FileUtils:FullFilePath(path), ...)
end
